import es
import effectlib
import random
import services

info = es.AddonInfo()
info.name = "Entity finder"
info.basename = 'entfinder'
info.author = 'GODJonez'
info.description = 'Locate specific entities'
info.version = '1.1a'

def requirements():
    if not services.isRegistered('auth'):
        es.dbgmsg(0, 'Cannot load %s - AUTH provider needed'%info.name)
        return False

    return True

AUTHCAP = 'find_entity'

def load():
    global auth
    if not requirements():
        es.soon('es_xunload %s'%info.basename)
        return False
    auth = services.use('auth')
    auth.registerCapability(AUTHCAP, auth.ADMIN)
    es.addons.registerClientCommandFilter(_ccf)
    if not es.exists('command', 'findent'):
        es.regcmd('findent', '%s/concmd'%info.basename, 'Find named entities')

def unload():
    es.addons.unregisterClientCommandFilter(_ccf)

def concmd():
    if es.getargc() < 2:
        es.dbgmsg(0, 'Usage: findent <classname>')
    else:
        findents(es.getargv(1), es.getplayerlocation(es.getuserid()))

def findents(name, loc2):
    ents = es.createentitylist(name)
    for ent in ents:
        loc = es.getindexprop(ent, 'CBaseEntity.m_vecOrigin')
        effectlib.drawLine(loc2, loc, seconds=5,
                           red = random.randint(128,255),
                           green=random.randint(128,255),
                           blue =random.randint(128,255))

def _ccf(userid, args):
    if len(args) == 0:
        return True
    if args[0] == 'findent':
        if not auth.isUseridAuthorized(userid, AUTHCAP):
            es.cexec(userid, 'echo You are not allowed to use this command')
            return False
        if len(args) == 1:
            es.cexec(userid, 'echo Usage: findent <classname>')
        else:
            findents(args[1], es.getplayerlocation(userid))
        return False
    return True
